=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.2.3

=end

require 'cgi'

module PulpDebClient
  class RemotesAptApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create an apt remote
    # An AptRemote represents an external APT repository content source.  It contains the location of the upstream APT repository, as well as the user options that are applied when using the remote to synchronize the upstream repository to Pulp.
    # @param deb_apt_remote [DebAptRemote] 
    # @param [Hash] opts the optional parameters
    # @return [DebAptRemoteResponse]
    def create(deb_apt_remote, opts = {})
      data, _status_code, _headers = create_with_http_info(deb_apt_remote, opts)
      data
    end

    # Create an apt remote
    # An AptRemote represents an external APT repository content source.  It contains the location of the upstream APT repository, as well as the user options that are applied when using the remote to synchronize the upstream repository to Pulp.
    # @param deb_apt_remote [DebAptRemote] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(DebAptRemoteResponse, Integer, Hash)>] DebAptRemoteResponse data, response status code and response headers
    def create_with_http_info(deb_apt_remote, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RemotesAptApi.create ...'
      end
      # verify the required parameter 'deb_apt_remote' is set
      if @api_client.config.client_side_validation && deb_apt_remote.nil?
        fail ArgumentError, "Missing the required parameter 'deb_apt_remote' when calling RemotesAptApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/remotes/deb/apt/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(deb_apt_remote) 

      # return_type
      return_type = opts[:return_type] || 'DebAptRemoteResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RemotesAptApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete an apt remote
    # Trigger an asynchronous delete task
    # @param deb_apt_remote_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def delete(deb_apt_remote_href, opts = {})
      data, _status_code, _headers = delete_with_http_info(deb_apt_remote_href, opts)
      data
    end

    # Delete an apt remote
    # Trigger an asynchronous delete task
    # @param deb_apt_remote_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def delete_with_http_info(deb_apt_remote_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RemotesAptApi.delete ...'
      end
      # verify the required parameter 'deb_apt_remote_href' is set
      if @api_client.config.client_side_validation && deb_apt_remote_href.nil?
        fail ArgumentError, "Missing the required parameter 'deb_apt_remote_href' when calling RemotesAptApi.delete"
      end
      # resource path
      local_var_path = '{deb_apt_remote_href}'.sub('{' + 'deb_apt_remote_href' + '}', CGI.escape(deb_apt_remote_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RemotesAptApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List apt remotes
    # An AptRemote represents an external APT repository content source.  It contains the location of the upstream APT repository, as well as the user options that are applied when using the remote to synchronize the upstream repository to Pulp.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name name
    # @option opts [String] :name__in name__in
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :pulp_last_updated pulp_last_updated
    # @option opts [String] :pulp_last_updated__gt pulp_last_updated__gt
    # @option opts [String] :pulp_last_updated__gte pulp_last_updated__gte
    # @option opts [String] :pulp_last_updated__lt pulp_last_updated__lt
    # @option opts [String] :pulp_last_updated__lte pulp_last_updated__lte
    # @option opts [String] :pulp_last_updated__range pulp_last_updated__range
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginateddebAptRemoteResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List apt remotes
    # An AptRemote represents an external APT repository content source.  It contains the location of the upstream APT repository, as well as the user options that are applied when using the remote to synchronize the upstream repository to Pulp.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name name
    # @option opts [String] :name__in name__in
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :pulp_last_updated pulp_last_updated
    # @option opts [String] :pulp_last_updated__gt pulp_last_updated__gt
    # @option opts [String] :pulp_last_updated__gte pulp_last_updated__gte
    # @option opts [String] :pulp_last_updated__lt pulp_last_updated__lt
    # @option opts [String] :pulp_last_updated__lte pulp_last_updated__lte
    # @option opts [String] :pulp_last_updated__range pulp_last_updated__range
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginateddebAptRemoteResponseList, Integer, Hash)>] PaginateddebAptRemoteResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RemotesAptApi.list ...'
      end
      # resource path
      local_var_path = '/pulp/api/v3/remotes/deb/apt/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__in'] = opts[:'name__in'] if !opts[:'name__in'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'pulp_last_updated'] = opts[:'pulp_last_updated'] if !opts[:'pulp_last_updated'].nil?
      query_params[:'pulp_last_updated__gt'] = opts[:'pulp_last_updated__gt'] if !opts[:'pulp_last_updated__gt'].nil?
      query_params[:'pulp_last_updated__gte'] = opts[:'pulp_last_updated__gte'] if !opts[:'pulp_last_updated__gte'].nil?
      query_params[:'pulp_last_updated__lt'] = opts[:'pulp_last_updated__lt'] if !opts[:'pulp_last_updated__lt'].nil?
      query_params[:'pulp_last_updated__lte'] = opts[:'pulp_last_updated__lte'] if !opts[:'pulp_last_updated__lte'].nil?
      query_params[:'pulp_last_updated__range'] = opts[:'pulp_last_updated__range'] if !opts[:'pulp_last_updated__range'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginateddebAptRemoteResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RemotesAptApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update an apt remote
    # Trigger an asynchronous partial update task
    # @param deb_apt_remote_href [String] 
    # @param patcheddeb_apt_remote [PatcheddebAptRemote] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def partial_update(deb_apt_remote_href, patcheddeb_apt_remote, opts = {})
      data, _status_code, _headers = partial_update_with_http_info(deb_apt_remote_href, patcheddeb_apt_remote, opts)
      data
    end

    # Update an apt remote
    # Trigger an asynchronous partial update task
    # @param deb_apt_remote_href [String] 
    # @param patcheddeb_apt_remote [PatcheddebAptRemote] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def partial_update_with_http_info(deb_apt_remote_href, patcheddeb_apt_remote, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RemotesAptApi.partial_update ...'
      end
      # verify the required parameter 'deb_apt_remote_href' is set
      if @api_client.config.client_side_validation && deb_apt_remote_href.nil?
        fail ArgumentError, "Missing the required parameter 'deb_apt_remote_href' when calling RemotesAptApi.partial_update"
      end
      # verify the required parameter 'patcheddeb_apt_remote' is set
      if @api_client.config.client_side_validation && patcheddeb_apt_remote.nil?
        fail ArgumentError, "Missing the required parameter 'patcheddeb_apt_remote' when calling RemotesAptApi.partial_update"
      end
      # resource path
      local_var_path = '{deb_apt_remote_href}'.sub('{' + 'deb_apt_remote_href' + '}', CGI.escape(deb_apt_remote_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(patcheddeb_apt_remote) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RemotesAptApi#partial_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect an apt remote
    # An AptRemote represents an external APT repository content source.  It contains the location of the upstream APT repository, as well as the user options that are applied when using the remote to synchronize the upstream repository to Pulp.
    # @param deb_apt_remote_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [DebAptRemoteResponse]
    def read(deb_apt_remote_href, opts = {})
      data, _status_code, _headers = read_with_http_info(deb_apt_remote_href, opts)
      data
    end

    # Inspect an apt remote
    # An AptRemote represents an external APT repository content source.  It contains the location of the upstream APT repository, as well as the user options that are applied when using the remote to synchronize the upstream repository to Pulp.
    # @param deb_apt_remote_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(DebAptRemoteResponse, Integer, Hash)>] DebAptRemoteResponse data, response status code and response headers
    def read_with_http_info(deb_apt_remote_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RemotesAptApi.read ...'
      end
      # verify the required parameter 'deb_apt_remote_href' is set
      if @api_client.config.client_side_validation && deb_apt_remote_href.nil?
        fail ArgumentError, "Missing the required parameter 'deb_apt_remote_href' when calling RemotesAptApi.read"
      end
      # resource path
      local_var_path = '{deb_apt_remote_href}'.sub('{' + 'deb_apt_remote_href' + '}', CGI.escape(deb_apt_remote_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DebAptRemoteResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RemotesAptApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update an apt remote
    # Trigger an asynchronous update task
    # @param deb_apt_remote_href [String] 
    # @param deb_apt_remote [DebAptRemote] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def update(deb_apt_remote_href, deb_apt_remote, opts = {})
      data, _status_code, _headers = update_with_http_info(deb_apt_remote_href, deb_apt_remote, opts)
      data
    end

    # Update an apt remote
    # Trigger an asynchronous update task
    # @param deb_apt_remote_href [String] 
    # @param deb_apt_remote [DebAptRemote] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def update_with_http_info(deb_apt_remote_href, deb_apt_remote, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RemotesAptApi.update ...'
      end
      # verify the required parameter 'deb_apt_remote_href' is set
      if @api_client.config.client_side_validation && deb_apt_remote_href.nil?
        fail ArgumentError, "Missing the required parameter 'deb_apt_remote_href' when calling RemotesAptApi.update"
      end
      # verify the required parameter 'deb_apt_remote' is set
      if @api_client.config.client_side_validation && deb_apt_remote.nil?
        fail ArgumentError, "Missing the required parameter 'deb_apt_remote' when calling RemotesAptApi.update"
      end
      # resource path
      local_var_path = '{deb_apt_remote_href}'.sub('{' + 'deb_apt_remote_href' + '}', CGI.escape(deb_apt_remote_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(deb_apt_remote) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RemotesAptApi#update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
